# include <iostream>
using namespace std;

const int MAX=4e6+11;
long long MOD;

int n;

void read()
{
    cin>>n>>MOD;
}

long long dp[MAX];
long long pref[MAX];

long long Get(int x)
{
    return n-x+1;
}

long long sum(int l, int r)
{
    //cout<<"Sum of:"<<l<<" "<<r<<"="<<(dp[l]-dp[r+1]+MOD)%MOD<<"\n";
    return (pref[l]-pref[r+1]+MOD)%MOD;
}

void solve()
{
    dp[n]=1;
    pref[n]=1;
    for(int i=n-1;i>=1;i--)
    {
        dp[i]=(dp[i]+pref[i+1])%MOD;

        for(int j=2;j*i<=n;j++)
        {
            int l=i*j, r=min(n,i*j+j-1);
            //cout<<i<<"->"<<l<<" "<<r<<"\n";
            dp[i]=(dp[i]+sum(l,r))%MOD;
        }

        pref[i]=(pref[i+1]+dp[i])%MOD;

        //cout<<i<<":"<<dp[i]<<" "<<pref[i]<<"\n";
    }

    cout<<dp[1]<<"\n";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    read();
    solve();

    return 0;
}

