# include <iostream>
# include <algorithm>
using namespace std;

const int MAX=1e7+11;

int n,m,p;
int z[MAX];

void z_func(string& s)
{
    int l=0, r=0;
    for(int i=1;i<n+m;i++)
    {
        if(r>i) z[i]=min(r-i,z[i-l]);
        while(i+z[i]<n+m and s[z[i]]==s[i+z[i]]) z[i]++;
        if(i+z[i]>r)
        {
            l=i;
            r=i+z[i];
        }
    }
}

int z2[MAX];
int suf[MAX];

void z_func2(string& s)
{
    int l=0, r=0;
    for(int i=1;i<n+m;i++)
    {
        if(r>i) z2[i]=min(r-i,z2[i-l]);
        while(i+z2[i]<n+m and s[z2[i]]==s[i+z2[i]]) z2[i]++;
        if(i+z2[i]>r)
        {
            l=i;
            r=i+z2[i];
        }
    }

    //cout<<s<<"\n";
    //for(int i=0;i<n+m;i++) cout<<z2[i]<<" ";
    //cout<<"\n";

    int last=m;
    for(int i=m;i<n+m;i++)
    {
        if(last+z2[last]<i+z2[i]) last=i;
        if(last<=i and last+z2[last]-1>=i) suf[i]=last+z2[last]-1-i+1;

        //cout<<i-m<<":"<<suf[i]<<"\n";
    }

    for(int i=m;i<n+m;i++)
    {
        int curr=i-m;
        //cout<<i-m<<" "<<n+m-1-(i-m)-m<<"\n";
        if(i<n+m-1-(i-m)) swap(suf[i],suf[n+m-1-(i-m)]);
        else break;

        //cout<<i-m<<" "<<n+m-1-(i-m)-m<<"\n";
    }
}

void solve()
{
    cin>>n>>m>>p;
    string s, s2;
    cin>>s>>s2;
    reverse(s2.begin(),s2.end());

    if(m==p)
    {
        cout<<"Zu"<<"\n";
        return ;
    }

    s2=s2.substr(0,p+1);
    //cout<<s2<<"\n";

    m=p+1;
    string s3=s2+s;
    z_func(s3);


    reverse(s2.begin(),s2.end());
    reverse(s.begin(),s.end());
    s3=s2+s; ///moji da go optimizirash
    z_func2(s3);


    //for(int i=m;i<n+m;i++) cout<<i-m<<":"<<z[i]<<" "<<suf[i]<<"\n";


    for(int i=m;i<n+m;i++)
    {
        if(z[i]>p) {cout<<"K"<<"\n"<<-1<<"\n";return ;}
    }

    for(int i=m;i<n+m;i++)
    {
        if(z[i]==0) continue;
        int nxt=i+z[i]+1;
        //cout<<i<<"->"<<nxt<<"\n";
        if(nxt<n+m and z[i]+suf[nxt]>p) {cout<<"K"<<"\n"<<i+z[i]-m<<"\n";return ;}
    }

    cout<<"Zu"<<"\n";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    solve();

    return 0;
}


/*
5 6 3
abzab
cbbaba
*/
