#include <iostream>
#include <algorithm>
using namespace std;
const int maxN = 1e6 + 7;
int z[2][maxN + maxN];
string att, def;
string all;
int p;

void zFunction(const string& s, int n, bool scndIt) {
	int l = 0, r = 0;
	for (int i = 1; i < n; i++) {
		if (i < r) {
			if (z[scndIt][i - l] < r - i) {
				z[scndIt][i] = z[scndIt][i - l];
			} else {
                l = i;
                while (r < n && s[r] == s[r - l]) {
                    r++;
                }
                z[scndIt][i] = r - l;
            }
		} else {
			l = i; r = i;
			while (r < n && s[r] == s[r - l]) {
				r++;
			}
			z[scndIt][i] = r - l;
		}
	}
}
/**
7 9 3
aaabzab
xxxbaabaa
*/
int main () {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m >> p;
	cin >> def >> att;
	if (p == m) {
		cout << "Zu";
		return 0;
	}

	reverse(att.begin(), att.end());
	///only care about first p + 1 elements of att
	att.erase(att.begin() + p + 1, att.end());

	m = p + 1;

	all = att + '#' + def;
	zFunction(all, all.size(), 0);
	for (int i = m; i < all.size(); i++) {
		if (z[0][i] > p) {
			cout << "K-1\n";
			return 0;
		}
	}

	reverse(all.begin(), all.begin() + p+1);
	reverse(all.begin() + p+2, all.end());
	zFunction(all, all.size(), 1);

//	cout << all << '\n';
//	for (int i = m+1; i < m+1 + n; i++) {
//		cout << z[1][i] << ' ';
//	}
//	cout << '\n';

	for (int i = 0; i < n - p; i++) {
		if (z[0][i + m+1] + z[1][n-(i + p + 2) + m+1] > p) {
			cout << "K\n" << i + z[0][i + m+1];
			return 0;
		}
	}

	cout << "Zu";

}
