#include <bits/stdc++.h>
using namespace std;

#define out(x) #x << " = " << x << " "
#ifndef LOCAL
#define endl "\n"
#define cerr \
	if (false) cerr
#define stdio(false) stdio(true)
#endif

const int MAX_N = 2 * 1e6 + 10;
const int INF = 1e9 + 10;

int n, m;
string a, b;

int z[MAX_N];

void zFunc(const string& s) {
	int sz = s.size();
	for (int i = 0; i < sz; i++) {
		z[i] = 0;
	}

	int l = 0, r = 0;
	for (int i = 1; i < sz; i++) {
		if (i < r) {
			z[i] = min(z[i - l], sz - i);
		}

		while (i + z[i] < sz && s[z[i]] == s[i + z[i]]) z[i]++;

		if (i + z[i] > r) {
			l = i;
			r = i + z[i];
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int p;
	cin >> n >> m >> p;
	cin >> b >> a;

	reverse(a.begin(), a.end());

	string c = a + "#" + b;

	zFunc(c);

	int ans = 0;
	for (int i = a.size() + 1; i < c.size(); i++) {
		ans = max(ans, z[i]);
	}

	if (ans > p) {
		cout << "K" << endl;
		cout << -1 << endl;
	} else {
		cout << "Zu" << endl;
	}

	return 0;
}