#include <bits/stdc++.h>
using namespace std;

#define out(x) #x << " = " << x << " "
#ifndef LOCAL
#define endl "\n"
#define cerr \
	if (false) cerr
#define stdio(false) stdio(true)
#endif

const int MAX_N = 2 * 1e6 + 10;
const int INF = 1e9 + 10;

int n, m;
string a, b;

int z[MAX_N];

void zFunc(const string& s, int startInd) {
	int sz = s.size();
	for (int i = startInd; i < sz; i++) {
		z[i] = 0;
	}

	int l = 0, r = 0;
	for (int i = startInd; i < sz; i++) {
		if (i < r) {
			z[i] = min(z[i - l], r - i);
		}

		while (i + z[i] < sz && s[z[i]] == s[i + z[i]]) z[i]++;

		if (i + z[i] > r) {
			l = i;
			r = i + z[i];
		}
	}
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	int p;
	cin >> n >> m >> p;
	cin >> b >> a;

	reverse(a.begin(), a.end());

	string c = a + "#" + b;

	zFunc(c, a.size() + 1);

	int ans = 0, skippedIndex = -1;
	for (int i = a.size() + 1; i < c.size(); i++) {
		ans = max(ans, z[i]);
	}

	cerr << ans << endl;

	for (int t = 0; t < b.size(); t++) {
		c = a + "#";

		for (int i = 0; i < b.size(); i++) {
			if (i == t) continue;
			c += b[i];
		}

		zFunc(c, a.size() + 1);

		cerr << c << endl;
		cerr << "Z-index: " << endl;
		int currentAns = 0;
		for (int i = a.size() + 1; i < c.size(); i++) {
			cerr << z[i] << " ";
			currentAns = max(currentAns, z[i]);
		}
		cerr << endl;

		cerr << currentAns << endl;

		if (currentAns > ans) {
			ans = currentAns;
			skippedIndex = t;
		}
	}

	cerr << "Answer " << out(ans) << endl;

	if (ans > p) {
		cout << "K" << endl;
		cout << skippedIndex << endl;
	} else {
		cout << "Zu" << endl;
	}

	return 0;
}