#include <bits/stdc++.h>

#define endl '\n'

using namespace std;

typedef long long ll;

const int MAXN = 2e6 + 10;

string s, t;
int n, m, p;

int z[MAXN];

void read()
{
    cin >> n >> m >> p;
    cin >> s >> t;

    reverse(t.begin(), t.end());
}

void z_function(string str)
{
    int left = 0;
    int right = 0;
    int sz = str.size();

    for(int i = 0; i < sz; i++)
    {
        z[i] = 0;
    }

    for(int i = 1; i < sz; i++)
    {
        if(i < right)
            z[i] = min(z[i - left], right - i);

        while(i + z[i] < sz && str[z[i]] == str[i + z[i]])
            z[i]++;

        if(i + z[i] > right)
        {
            left = i;
            right = i + z[i];
        }
    }
}

void solve()
{
    string str = t + "#" + s;

    z_function(str);

    int sz = str.size();
    int from = t.size() + 1;

    for(int i = from; i < sz; i++)
    {
        if(z[i] > p)
        {
            cout << "K" << endl;
            cout << -1 << endl;
            return;
        }
    }

    cout << "Zu" << endl;
}

int main()
{
    ios_base :: sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    read();
    solve();

    return 0;
}