#include <bits/stdc++.h>

using namespace std;

const int maxn = 4000005;

int n, m;
long long dp[maxn];
long long suff[maxn];

long long sum(int from, int to)
{
    return suff[from] - suff[to + 1];
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m;

    dp[n] = 1;
    suff[n] = 1;

    for (int i = n; i > 1; --i)
    {
        for (int j = i - 1; j >= 1; --j)
        {
            dp[j] += dp[i];
            if (dp[j] >= m) dp[j] -= m;
        }

        for (int j = 2; j <= i; ++j)
        {
            dp[i / j] += dp[i];
            if (dp[i / j] >= m) dp[i / j] -= m;
        }
    }

    cout << dp[1] << endl;

    return 0;
}
