#include <bits/stdc++.h>

using namespace std;

const int maxn = 4000005;

int n, m;
long long dp[maxn];
long long suff[maxn];

long long sum(int from, int to)
{
    return suff[from] - suff[to + 1];
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m;

    dp[n] = 1;
    suff[n] = 1;

    for (int i = n - 1; i >= 1; --i)
    {
        dp[i] = suff[i + 1];

        for (int j = 2; i * j <= n; ++j)
        {
            dp[i] += sum(i * j, min(n + 1, (i + 1) * j - 1));
            if (dp[i] >= m) dp[i] -= m;
        }

        suff[i] = suff[i + 1] + dp[i];
        if (suff[i] >= m) suff[i] -= m;
    }

    cout << dp[1] << endl;

    return 0;
}
