#include <bits/stdc++.h>

using namespace std;

const int maxn = 4000005;

int n, m;
long long dp[maxn];
long long pref[maxn];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m;

    dp[1] = 1;
    pref[1] = 1;
    int prv;

    for (int i = 2; i <= n; ++i)
    {
        dp[i] = pref[i - 1];

        for (int j = 2; j <= i; ++j)
        {
            prv = i / j;
            int l = j + 1;
            int r = i;

            while (l <= r)
            {
                int mid = (l + r) / 2;

                if (i / mid == prv)
                {
                    l = mid + 1;
                }
                else
                {
                    r = mid - 1;
                }
            }

            dp[i] += (1LL * (r - j + 1)) * dp[prv];
            dp[i] %= m;
            j = r;
        }

        pref[i] = pref[i - 1] + dp[i];
        pref[i] %= m;
    }

    cout << dp[n] << endl;

    return 0;
}
