#include <bits/stdc++.h>

using namespace std;

const int maxn = 1000005;
const long long BASE1 = 137;
const long long mod1 = 998244353;

int n, m, p;
char s[maxn];
char t[maxn];

long long pref1[maxn];
long long power1[maxn];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> n >> m >> p;

    for (int i = 1; i <= n; ++i)
    {
        cin >> s[i];
    }

    for (int i = 1; i <= m; ++i)
    {
        cin >> t[i];
    }

    reverse(t + 1, t + m + 1);

    ++p;

    if (p > m || p > n)
    {
        cout << "Zu" << endl;
        return 0;
    }

    power1[0] = 1;

    for (int i = 1; i <= n; ++i)
    {
        power1[i] = (power1[i - 1] * BASE1) % mod1;
        pref1[i] = (pref1[i - 1] * BASE1 + s[i]) % mod1;
    }

    long long target1 = 0;

    for (int i = 1; i <= p; ++i)
    {
        target1 = (target1 * BASE1 + t[i]) % mod1;
    }

    for (int i = 1; i <= n - p + 1; ++i)
    {
        int to = i + p - 1;
        long long curr1 = (pref1[to] + mod1 * mod1 - pref1[i - 1] * power1[p]) % mod1;

        if (curr1 == target1)
        {
            cout << "K" << endl;
            cout << -1 << endl;
            return 0;
        }
    }

    cout << "Zu" << endl;

    return 0;
}
