#include <iostream>

using std::cin;
using std::cout;

#define endl '\n'
typedef int _int;
#define int long long
#define MAXN 4000000


//int solve(int n) {
//    if (n == 1) {
//        return 1;
//    }
//
//    int sum = 0;
//
//    for (int i = 2; i <= n; i++) {
//        if (dp[n / i]) {
//            sum += dp[n / i];
//        } else {
//            sum += solve(n / i);
//        }
//        sum %= m;
//    }
//    for (int i = 1; i < n; i++) {
//        if (dp[i]) {
//            sum += dp[i];
//        } else {
//            sum += solve(i);
//        }
//        sum %= m;
//    }
//
//    return dp[n] = sum;
//}


int n, m;
int dp[MAXN + 1];
int tmp[MAXN];
int solve(int n) {
    if (n == 1) {
        return 1;
    }

    for (int i = 1; i < n; i++) {
        tmp[i] = 1;
    }
    for (int i = 2; i <= n; i++) {
        tmp[n / i]++;
    }

    int res = 0;
    for (int i = 1; i < n; i++) {
        if (dp[i]) {
            res += tmp[i] * dp[i];
        } else {
            res += tmp[i] * solve(i);
        }
        res %= m;
    }

    return dp[n] = res;
} 

_int main(_int argc, const char** argv) {
    std::ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin >> n >> m;
    cout << solve(n) << endl;

    return 0;
}
