# include <iostream>
# include <vector>
# include <cassert>
using namespace std;

const int MAXN=1e5+11, MAXP=1e2+11;
const long long INF=1e18;

long long n,p,d;
long long a[MAXN];

void read()
{
    long long b;
    cin>>b>>p>>d>>n;
    a[n+1]=b;
    for(int i=1;i<=n;i++) cin>>a[i];
    n++;

    if(n>MAXN or p>MAXP) assert(0);
}

long long cnt(long long t)
{
    if(t<0) return 0;
    return t/p+1;
}

long long dp[MAXN][MAXP];
int g[3];

void solve()
{
    for(int i=1;i<=n;i++)
    {
        for(int j=0;j<p;j++) dp[i][j]=INF;
    }

    int nxt=0;
    for(int t=0;t<=0;t++)
    {
        long long enter=a[1]+t;
        long long dm=enter+enter/p*d;
        if(enter%p==0) dm-=d;

        nxt=enter%p;
        dp[1]=dm;
    }

    for(int i=1;i<n;i++)
    {
        for(int j=nxt;j<=nxt;j++)
        {

            //cout<<i<<" "<<j<<":"<<dp[i][j]<<"\n";
            g[0]=0;
            g[1]=p-j;
            g[2]=p-((j+a[i+1]-a[i])%p);

            for(int tt=0;tt<=0;tt++)
            {
                int t=g[tt];

                long long exit=(j+t+1)%p;
                long long dist=a[i+1]-a[i];
                long long enter=(exit+dist-1+p)%p;
                long long l=exit, r=dist+exit-1, tm=cnt(r)-cnt(l-1);
                if(cnt(r)-cnt(r-1)==1) tm--;

                long long dm=dist+tm*d+dp[i][j]+t;

                //if(i==2 and j==3) cout<<i<<" "<<j<<" "<<t<<"->"<<enter<<":"<<tm<<" "<<dm<<"\n";
                dp[i+1][enter]=min(dp[i+1][enter],dm);
            }
        }
    }

    long long ans=INF;
    for(int i=0;i<p;i++) ans=min(ans,dp[n][i]);

    cout<<ans<<"\n";
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);cout.tie(0);

    read();
    solve();

    return 0;
}

