#include <iostream>
using namespace std;
typedef long long ll;
const ll maxN = 4e6 + 7;
ll dp[maxN];
ll suf[maxN + 1];

int main () {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);
	ll n, m;
	cin >> n >> m;
	suf[n + 1] = 0;
	dp[n] = suf[n] = 1;
	for (ll i = n - 1; i >= 1; i--) {
		dp[i] = suf[i + 1];
		dp[i] %= m;
		for (ll j = 2; i * j <= n; j++) {
			ll st = i * j, end = min(n + 1, i * j + j);
			dp[i] += suf[st] - suf[end];
			dp[i] %= m;
		}
		suf[i] = suf[i + 1] + dp[i];
	}
	cout << dp[1];
}
