#include <iostream>
#include <algorithm>
using namespace std;
const int maxN = 1e6 + 7;
int z[maxN];
string att, def;
string all;
int p;

void zFunction(const string& s, int n) {
	int l = 0, r = 0;
	for (int i = 1; i < n; i++) {
		if (i < r) {
			if (z[i - l] < r - i) {
				z[i] = z[i - l];
			} else {
                l = i;
                while (r < n && s[r] == s[r - l]) {
                    r++;
                }
                z[i] = r - l;
            }
		} else {
			l = i; r = i;
			while (r < n && s[r] == s[r - l]) {
				r++;
			}
			z[i] = r - l;
		}
	}
}

int main () {
	ios_base::sync_with_stdio(0);
	cin.tie(0);
	cout.tie(0);

	int n, m;
	cin >> n >> m >> p;
	cin >> def >> att;
	reverse(att.begin(), att.end());
	all = att + '#' + def;
	zFunction(all, all.size());
	for (int i = m; i < all.size(); i++) {
		if (z[i] > p) {
			cout << "K\n-1";
			return 0;
		}
	}
	cout << "Zu";

}
