#include <bits/stdc++.h>
using namespace std;

#define out(x) #x << " = " << x << " "
#ifndef LOCAL
#define endl "\n"
#define cerr \
	if (false) cerr
#define stdio(false) stdio(true)
#endif

const int MAX_N = 1e5 + 10;
const int INF = 1e9 + 10;

int b, p, d, n;
int shelds[MAX_N];
bool isThereASheld[1005];

int bestDamage = INF;

void solve(int pos, int time, int currentAns) {
	if (pos >= b) {
		bestDamage = min(bestDamage, currentAns);
		return;
	}

	if (currentAns > bestDamage) return;

	int adding = 1;
	if (time % p == 0 && time != 0 && !isThereASheld[pos]) adding += d;

	solve(pos + 1, time + 1, currentAns + adding);
	solve(pos, time + 1, currentAns + adding);
}

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	cin >> b >> p >> d >> n;

	int cntShelded = 0;

	for (int i = 0; i < n; i++) {
		cin >> shelds[i];
		isThereASheld[shelds[i]] = true;

		if (shelds[i] % p == 0) cntShelded++;
	}
	isThereASheld[0] = true;
	isThereASheld[b] = true;

	int baseDamage = b + (b / p - cntShelded) * d;
	bestDamage = baseDamage;
	cerr << bestDamage << endl;

	solve(0, 0, 0);

	cout << bestDamage << endl;

	return 0;
}