#include <bits/stdc++.h>
using namespace std;

#define out(x) #x << " = " << x << " "
#ifndef LOCAL
#define endl "\n"
#define cerr \
	if (false) cerr
#define stdio(false) stdio(true)
#endif

const int MAX_N = 4 * 1e6 + 10;
const int INF = 1e9 + 10;

long long dp[MAX_N];

int main() {
	ios_base::sync_with_stdio(false);
	cin.tie(NULL);
	cout.tie(NULL);

	long long n, m;
	cin >> n >> m;

	long long sum = (1 + 2) % m;

	dp[1] = 1 % m;
	dp[2] = 2 % m;

	for (int i = 3; i <= n; i++) {
		dp[i] = sum;

		for (int j = 2; j <= i; j++) {
			dp[i] = (dp[i] + dp[i / j]) % m;
		}

		sum = (sum + dp[i]) % m;
	}

	cout << dp[n] << endl;
	return 0;
}