#include<bits/stdc++.h>
using namespace std;

const long long MOD = 1e9+9;
long long pr1[1000001];
long long pr2[1000001];
long long inv[1000001];

long long calc(long long a, long long b) {
    if(b == 0) {
        return 1;
    }
    long long ans = calc(a,b/2);
    ans*=ans;
    ans%=MOD;
    if(b%2) {
        ans*=a;
        ans%=MOD;
    }
    return ans;
}

bool check(int l1, int r1, int l2, int r2) {
    l1--;
    l2--;
    long long c = pr1[r1]-pr1[l1]+MOD,d = pr2[r2]-pr2[l2]+MOD;
    c*=inv[l1];
    d*=inv[l2];
    c%=MOD;
    d%=MOD;
    return c == d;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    int n,m,p;
    cin >> n >> m >> p;
    inv[0] = 1;
    int x = calc(26,MOD-2);
    for(int i = 1; i <= 1000000; i++) {
        inv[i] = (x*inv[i-1])%MOD;
    }
    string s,t;
    cin >> s >> t;
    reverse(t.begin(),t.end());
    p++;
    if(p > t.size()) {
        cout << "Zu" << endl;
        return 0;
    }
    pr1[0] = 0;
    long long y = 1;
    for(int i = 1; i <= s.size(); i++) {
        pr1[i] = (pr1[i-1]+y*(s[i-1]-'a'))%MOD;
        y*=26;
        y%=MOD;
    }
    pr2[0] = 0;
    y = 1;
    for(int i = 1; i <= t.size(); i++) {
        pr2[i] = (pr2[i-1]+y*(t[i-1]-'a'))%MOD;
        y*=26;
        y%=MOD;
    }
    bool yeah = false;
    for(int i = 1; i <= n-p+1; i++) {
        if(check(i,i+p-1,1,p)) {
            yeah = true;
        }
    }
    if(yeah) {
        cout << "K\n";
        cout << -1;
    }
    else {
        cout << "Zu";
    }
    return 0;
}