/**
 ____    ____    ____    __________________    ____    ____    ____
||I ||  ||c ||  ||e ||  ||                ||  ||M ||  ||a ||  ||n ||
||__||  ||__||  ||__||  ||________________||  ||__||  ||__||  ||__||
|/__\|  |/__\|  |/__\|  |/________________\|  |/__\|  |/__\|  |/__\|

*/

#include <iostream>
#include <chrono>
#include <vector>
#include <algorithm>
#include <cmath>

#define maxn 100005
#define maxlog 20
#define INF 1000000010
#define LINF 1000000000000000005
#define endl '\n'
#define pb(x) push_back(x)
#define X first
#define Y second
#define control cout<<"passed"<<endl;

using namespace std;




typedef long long ll;




ll b , p , d , n;
ll a[maxn];

ll calc(ll l , ll r , ll d)
{
    ll f = ceil((double)(l) / d) * d;
    ll la = floor((double)(r) / d) * d;

    if(f > r)
        return 0;
    return ((la - f) / d) + 1;
}

ll get_next(ll num , ll d)
{
    //cout << "?? " << num << " " << d << endl;
    //cout << ceil((double)(num) / d) << endl;
    return ceil((double)(num) / d) * d;
}

void read_solve()
{
    cin >> b >> p >> d >> n;

    for(ll i = 1; i <= n; i++)
        cin >> a[i];

    ll br = 0;
    ll moment = 0;

    for(ll i = 1; i <= n; i++)
    {
        br += calc(moment + 1 , a[i] - 1 , p);
        moment += (a[i] - a[i - 1]);

        ll next = get_next(moment , p);

        if(next > b)
            continue;

        if(next - moment < d)
            moment = next;


    }

    br += calc(moment + 1 , moment + b - a[n] , p);
    moment += b - a[n];
    //cout << br << " " << moment << endl;

    cout << br * d + moment << endl;
}








int main()
{

/**#ifdef ONLINE_JUDGE
    freopen("input.in", "r", stdin);
    freopen("output.out", "w", stdout);
#endif*/

    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);

    //startT = std::chrono::high_resolution_clock::now();

    read_solve();


    return 0;
}
