#include <iostream>
#include <algorithm>

using std::cin;
using std::cout;
using std::string;
using std::reverse;

#define endl '\n'


int n, m, p;
string ku;
string zu;
int z[2000002];

void fillZArr(const string& str, int* Z) {
    int size = str.size();
    int L, R, k;

    L = R = 0;
    for (int i = 1; i < size; i++) {
        if (i > R) {
            L = R = i;
            while (R < size && str[R - L] == str[R]) {
                R++;
            }

            Z[i] = R - L;
            R--;

            continue;
        }

        k = i - L;
        if (Z[k] < R - i + 1) {
            Z[i] = Z[k];

            continue;
        }

        L = i;
        while (R < size && str[R - L] == str[R]) {
            R++;
        }
        Z[i] = R - L;
        R--;
    }
    Z[0] = -1;
}

int main(int argc, const char** argv) {
    std::ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);

    cin >> n >> m >> p;
    cin >> ku;
    cin >> zu;

    reverse(zu.begin(), zu.end());
    string str = zu + "$" + ku;
    fillZArr(str, z);

    int resI = 0;
    for (int i = zu.size() + 1; i < str.size(); i++) {
        if (z[resI] < z[i]) {
            resI = i;
        }
    }
    if (z[resI] >= p) {
        cout << "K" << endl;
        cout << "-1" << endl;
        //cout << resI << endl;
        //cout << z[resI] << endl;
        
        return 0;
    } else {
        cout << "Zu" << endl;
        
        return 0;
    }

    return 0;
}


/*
5 6 2
abab
cbbaba
*/